Index: /pjproject/trunk/pjsip-apps/src/pjsua/main.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/main.c	(revision 4439)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/main.c	(revision 4440)
@@ -30,6 +30,7 @@
 pj_status_t app_init(int argc, char *argv[]);
 pj_status_t app_main(void);
-pj_status_t app_destroy(void);
-
+pj_status_t app_destroy();
+pj_status_t receive_end_sig;
+pj_thread_t *sig_thread;
 
 #if defined(PJ_WIN32) && PJ_WIN32!=0
@@ -39,7 +40,5 @@
 
 static BOOL WINAPI CtrlHandler(DWORD fdwCtrlType)
-{
-    pj_thread_t *thread;
-
+{   
     switch (fdwCtrlType) 
     { 
@@ -51,7 +50,8 @@
         case CTRL_LOGOFF_EVENT: 
         case CTRL_SHUTDOWN_EVENT: 
-	    pj_thread_register("ctrlhandler", handler_desc, &thread);
+	    pj_thread_register("ctrlhandler", handler_desc, &sig_thread);
 	    PJ_LOG(3,(THIS_FILE, "Ctrl-C detected, quitting.."));
-            app_destroy();
+	    receive_end_sig = PJ_TRUE;
+            app_destroy();	    
 	    ExitProcess(1);
             PJ_UNREACHED(return TRUE;)
@@ -88,4 +88,5 @@
 static int main_func(int argc, char *argv[])
 {
+    receive_end_sig = PJ_FALSE;
     setup_socket_signal();
 
@@ -99,8 +100,12 @@
 
 	app_main();
-	app_destroy();
+	if (!receive_end_sig) {
+	    app_destroy();
 
-	/* This is on purpose */
-	app_destroy();
+	    /* This is on purpose */
+	    app_destroy();
+	} else {
+	    pj_thread_join(sig_thread);
+	}
     } while (app_restart);
 
